/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.objectweb.petals.ws.notification;

import javax.xml.namespace.QName;

import org.objectweb.petals.ws.topic.Topic;

/**
 * 
 * @author chamerling - eBM WebSourcing
 * 
 */
public abstract class Filter {

    protected QName topicName;

    protected String topicExpression;

    protected Topic topic;

    /**
     * Creates a new instance of {@link Filter}
     * 
     */
    public Filter() {
    }

    /**
     * Accept the notification message
     * 
     * @param message
     * @return
     */
    protected abstract boolean accept(NotificationMessage message);

    /**
     * @return the topic
     */
    public Topic getTopic() {
        return this.topic;
    }

    /**
     * @param topic
     *            the topic to set
     */
    public void setTopic(Topic topic) {
        this.topic = topic;
    }

    /**
     * @return the topicExpression
     */
    public String getTopicExpression() {
        return this.topicExpression;
    }

    /**
     * @param topicExpression
     *            the topicExpression to set
     */
    public void setTopicExpression(String topicExpression) {
        this.topicExpression = topicExpression;
    }

    /**
     * @return the topicName
     */
    public QName getTopicName() {
        return this.topicName;
    }

    /**
     * @param topicName
     *            the topicName to set
     */
    public void setTopicName(QName topicName) {
        this.topicName = topicName;
    }
}
