/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.objectweb.petals.ws.notification;

import javax.xml.namespace.QName;

import org.objectweb.petals.ws.fault.WsnFault;
import org.objectweb.petals.ws.topic.WstConstants;

/**
 * A filter based on topic expression
 * 
 * @author chamerling - eBM WebSourcing
 * 
 */
public class TopicExpressionFilter extends Filter {

    /**
     * Creates a new instance of {@link TopicExpressionFilter}
     * 
     * @param topicName
     */
    public TopicExpressionFilter(QName topicName) throws WsnFault {
        this(topicName, WstConstants.CONCRETE_TOPIC_URI);
    }

    // /**
    // * Creates a new instance of {@link TopicExpressionFilter}
    // *
    // * @param topic
    // * @param dialect
    // */
    // public TopicExpressionFilter(Topic topic, String dialect) {
    // // this(topic.getConcretePath(), dialect);
    // }

    /**
     * Creates a new instance of {@link TopicExpressionFilter}
     * 
     */
    public TopicExpressionFilter(QName topicName, String dialect)
            throws WsnFault {
        if (!dialect.equals(WstConstants.CONCRETE_TOPIC_URI)) {
            throw new WsnFault("");
        }
        this.topicName = topicName;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.petals.ws.notification.Filter#accept(org.objectweb.petals.ws.notification.NotificationMessage)
     */
    public boolean accept(NotificationMessage message) {
        boolean result = true;
        QName messageTopicName = message.getTopic();

        if (messageTopicName == null) {
            return false;
        } else {
            // temp, only compare Topic QName
            if (messageTopicName.equals(this.topicName)) {
                result = true;
            } else {
                result = false;
            }
        }

        return result;

        // TODO : real filter processing
        // if (!messageTopicName.equals(this.topicName)) {
        // return false;
        // }
        //
        // //
        // // if we haven't supplied the Topic data structure, we
        // // can't compare message types/patterns - must be a match
        // //
        // if (this.topic == null) {
        // return true;
        // }
        //
        // String pattern = this.topic.getMessagePattern();
        //
        // //
        // // no pattern to compare? it's a match
        // //
        // if (pattern == null) {
        // return true;
        // }
        //
        // // xpath validation
        // OMDocument document = AxiomHelper.createEmptyDocument();
        // document.addChild(WsnHelper.notificationMessageToOM(message));
        // XPathEvaluator xpathEval = new XPathEvaluator();
        // try {
        // List evalList = xpathEval.evaluateXpath(pattern, document, null);
        // result = (evalList.size() > 0);
        // } catch (Exception e) {
        // result = false;
        // }
        // return result;
    }
}
